VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MyMemory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'class name :MyMemory
'by Xing
'2/16/1999


Option Explicit


Private Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type


Private Const GMEM_MOVEABLE& = &H2
Private Const GMEM_ZEROINIT& = &H40

Private Declare Function GlobalSize& Lib "kernel32" (ByVal hMem As Long)
Private Declare Function GlobalFree& Lib "kernel32" (ByVal hMem As Long)
Private Declare Function GlobalAlloc& Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long)
Private Declare Function GlobalLock& Lib "kernel32" (ByVal hMem As Long)
Private Declare Function GlobalUnlock& Lib "kernel32" (ByVal hMem As Long)
Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As MEMORYSTATUS)

'Members of the MyMemory class
Dim m_MemSize As Long                  'Memory size
Dim m_MemHandle As Long                'Memory handle
Dim m_MemPointer As Long               'Memory pointer
Dim m_MemStat As MEMORYSTATUS          'Memory info

'Get Memory info
Public Property Get dwLength() As Long
     dwLength = m_MemStat.dwLength
End Property
Public Property Get dwMemoryLoad() As Long
     dwMemoryLoad = m_MemStat.dwMemoryLoad
End Property
Public Property Get dwTotalPhys() As Long
     dwTotalPhys = m_MemStat.dwTotalPhys
End Property
Public Property Get dwAvaiPhys() As Long
     dwAvaiPhys = m_MemStat.dwAvailPhys
End Property
Public Property Get dwTotalPageFile() As Long
     dwTotalPageFile = m_MemStat.dwAvailPageFile
End Property
Public Property Get dwTotalVirtual() As Long
     dwTotalVirtual = m_MemStat.dwAvailVirtual
End Property
Public Property Get dwAvailVirtual() As Long
     dwAvailVirtual = m_MemStat.dwAvailVirtual
End Property

'Set/Get memory size
Public Property Let MemSize(L As Long)
     m_MemSize = L
End Property
Public Property Get MemSize() As Long
     MemSize = m_MemSize
End Property

'Set/Get memory handle
Public Property Let MemHandle(L As Long)
     m_MemHandle = L
End Property
Public Property Get MemHandle() As Long
     MemHandle = m_MemHandle
End Property

'Set/Get memory pointer
Public Property Let MemPointer(L As Long)
    m_MemPointer = L
End Property
Public Property Get MemPointer() As Long
    MemPointer = m_MemPointer
End Property

'Allocates the memory
Public Sub GAlloc()
    m_MemHandle = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, m_MemSize)
End Sub

'Locks the memory usage(עڴʱWindowsϵͳƶڴ)
Public Sub GLock()
    m_MemPointer = GlobalLock(m_MemHandle)
End Sub

'Unlocks the memory block
Public Sub GUnLock()
    Dim dl As Long
    dl& = GlobalUnlock(m_MemHandle)
End Sub

'Free the memory block
Public Sub GFree()
    Dim dl&
    dl& = GlobalFree(m_MemHandle)
End Sub

'ȡȫڴС
Public Function GSize() As Long
    GSize = GlobalSize(m_MemHandle)
End Function

'Fill the structure
Public Sub GetMemStat()
    Dim MemStat As MEMORYSTATUS
    MemStat.dwLength = Len(m_MemStat)
    Call GlobalMemoryStatus(m_MemStat)
End Sub
